#property copyright "Copyright  2010, VIKRAV"
#property link      "http://www.vikrav.com"

string gs76 = "BreakEven";
extern int LockInPipsAt = 40;
extern int LockInPips = 2;
extern int Trades = 1;
extern bool ModifyTrades = TRUE;
extern bool ModifyTrade3 = TRUE;
extern int FontSize = 8;
extern color FontColour = White;
double gdunused112;
double gd120;
double gd128;
string gs144 = "expert.wav";
string gsdummy152;
int gi160 = 3;
int gslippage164 = 0;
int gi168 = 0;

int init() {
   gd120 = Point;
   gdunused112 = Digits;
   gslippage164 = gi160;
   if (Digits == 5 || Digits == 3) {
      gdunused112 = Digits - 1;
      gd120 = 10.0 * Point;
      gslippage164 = 10 * gi160;
   }
   if (NormalizeDouble(MarketInfo(Symbol(), MODE_LOTSTEP), 2) == 0.01) gi168 = 2;
   else gi168 = 1;
   if (Trades > 3) Trades = 3;
   if (Trades < 1) Trades = 1;
   ObjectCreate("EA_Version", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("EA_Version", gs76 + " - Lock in " + LockInPips + " pips after " + LockInPipsAt + " pips profit", FontSize, "Arial", FontColour);
   ObjectSet("EA_Version", OBJPROP_XDISTANCE, 500);
   ObjectSet("EA_Version", OBJPROP_YDISTANCE, 0);
   if (Trades > 1) {
      ObjectCreate("Monitor1", OBJ_LABEL, 0, 0, 0);
      ObjectSetText("Monitor1", "Monitoring Targets: TP1 = " + LockInPipsAt + " Pips", FontSize, "Arial", FontColour);
      ObjectSet("Monitor1", OBJPROP_CORNER, 0);
      ObjectSet("Monitor1", OBJPROP_XDISTANCE, 500);
      ObjectSet("Monitor1", OBJPROP_YDISTANCE, FontSize + 10);
   }
   if (Trades > 1) {
      ObjectCreate("Monitor2", OBJ_LABEL, 0, 0, 0);
      ObjectSetText("Monitor2", "|| TP2 = " + (LockInPipsAt * 2) + " Pips", FontSize, "Arial", FontColour);
      ObjectSet("Monitor2", OBJPROP_CORNER, 0);
      ObjectSet("Monitor2", OBJPROP_XDISTANCE, 710);
      ObjectSet("Monitor2", OBJPROP_YDISTANCE, FontSize + 10);
   }
   if (Trades == 3) {
      ObjectCreate("Monitor3", OBJ_LABEL, 0, 0, 0);
      ObjectSetText("Monitor3", "|| TP3 = " + (3 * LockInPipsAt) + " Pips", FontSize, "Arial", FontColour);
      ObjectSet("Monitor3", OBJPROP_CORNER, 0);
      ObjectSet("Monitor3", OBJPROP_XDISTANCE, 815);
      ObjectSet("Monitor3", OBJPROP_YDISTANCE, FontSize + 10);
   }
   return (0);
}

int deinit() {
   ObjectDelete("EA_Version");
   ObjectDelete("Monitor1");
   ObjectDelete("Monitor2");
   ObjectDelete("Monitor3");
   return (0);
}

int start() {
   if (Digits == 5 || Digits == 3) gd128 = MarketInfo(Symbol(), MODE_SPREAD) / 10.0;
   else gd128 = MarketInfo(Symbol(), MODE_SPREAD);
   if (LockInPipsAt > 0) {
      for (int lpos0 = 0; lpos0 < OrdersTotal(); lpos0++) {
         OrderSelect(lpos0, SELECT_BY_POS, MODE_TRADES);
         if (OrderSymbol() == Symbol()) {
            switch (OrderType()) {
            case OP_BUY:
               if (iClose(OrderSymbol(), 0, 0) - OrderOpenPrice() >= LockInPipsAt * gd120) {
                  if (OrderStopLoss() < OrderOpenPrice()) {
                     OrderModify(OrderTicket(), OrderOpenPrice(), OrderOpenPrice() + LockInPips * gd120, OrderTakeProfit(), 0, CLR_NONE);
                     Print("Stop Loss adjusted to ", LockInPips, " pips");
                     PlaySound(gs144);
                     if (Trades > 1) {
                        OrderClose(OrderTicket(), NormalizeDouble(OrderLots() / Trades, gi168), Bid, gslippage164, CLR_NONE);
                        Print("Partial order closed to lock in profits by Breakeven EA");
                     }
                  }
               }
               if (Trades == 3 && ModifyTrades && iClose(OrderSymbol(), 0, 0) - OrderOpenPrice() >= LockInPipsAt * 2 * gd120) {
                  OrderModify(OrderTicket(), OrderOpenPrice(), OrderOpenPrice() + LockInPipsAt * gd120, OrderTakeProfit(), 0, CLR_NONE);
                  Print("Stop Loss adjusted to ", LockInPipsAt, " pips");
                  Sleep(500);
                  OrderClose(OrderTicket(), NormalizeDouble(OrderLots() / 2.0, gi168), Bid, gslippage164, CLR_NONE);
                  Print("Partial order closed to lock in profits");
                  ModifyTrades = FALSE;
                  PlaySound(gs144);
               }
               if (Trades == 3 && ModifyTrade3 && iClose(OrderSymbol(), 0, 0) - OrderOpenPrice() >= 3 * LockInPipsAt * gd120) {
                  OrderClose(OrderTicket(), OrderLots(), Bid, gslippage164, CLR_NONE);
                  Print("Final Order closed by Breakeven EA");
                  ModifyTrade3 = FALSE;
                  PlaySound(gs144);
               }
               break;
            case OP_SELL:
               if (OrderOpenPrice() - iClose(OrderSymbol(), 0, 0) >= LockInPipsAt * gd120) {
                  if (OrderStopLoss() > OrderOpenPrice()) {
                     OrderModify(OrderTicket(), OrderOpenPrice(), OrderOpenPrice() - LockInPips * gd120, OrderTakeProfit(), 0, Yellow);
                     Print("Stop Loss adjusted to ", LockInPips, " pips");
                     PlaySound(gs144);
                     if (Trades > 1) {
                        OrderClose(OrderTicket(), NormalizeDouble(OrderLots() / Trades, gi168), Ask, gslippage164, CLR_NONE);
                        Print("Partial order closed to lock in profits by Breakeven EA");
                     }
                  }
               }
               if (Trades == 3 && ModifyTrades && OrderOpenPrice() - iClose(OrderSymbol(), 0, 0) >= LockInPipsAt * 2 * gd120) {
                  OrderModify(OrderTicket(), OrderOpenPrice(), OrderOpenPrice() - LockInPipsAt * gd120, OrderTakeProfit(), 0, CLR_NONE);
                  Print("Stop Loss adjusted to ", LockInPipsAt, " pips");
                  Sleep(500);
                  OrderClose(OrderTicket(), NormalizeDouble(OrderLots() / 2.0, gi168), Ask, gslippage164, CLR_NONE);
                  Print("Partial order closed to lock in profits by Breakeven EA");
                  ModifyTrades = FALSE;
                  PlaySound(gs144);
               }
               if (Trades == 3 && ModifyTrade3 && OrderOpenPrice() - iClose(OrderSymbol(), 0, 0) >= 3 * LockInPipsAt * gd120) {
                  OrderClose(OrderTicket(), OrderLots(), Ask, gslippage164, CLR_NONE);
                  Print("Final Order closed by Breakeven EA");
                  ModifyTrade3 = FALSE;
                  PlaySound(gs144);
               }
            }
         }
      }
   }
   return (0);
}